# coding: utf-8

"""
    NetHSM
    All endpoints expect exactly the specified JSON. Additional properties will cause a Bad Request Error (400). All HTTP errors contain a JSON structure with an explanation of type string. All [base64](https://tools.ietf.org/html/rfc4648#section-4) encoded values are Big Endian.   # noqa: E501
    The version of the OpenAPI document: v1
    Generated by: https://github.com/openapi-json-schema-tools/openapi-json-schema-generator
"""

from __future__ import annotations
from pynitrokey.nethsm.client.shared_imports.schema_imports import *  # pyright: ignore [reportWildcardImportFromLibrary]

SystemTime: typing_extensions.TypeAlias = schemas.DateTimeSchema

from pynitrokey.nethsm.client.components.schema import passphrase
Properties = typing.TypedDict(
    'Properties',
    {
        "unlockPassphrase": typing.Type[passphrase.Passphrase],
        "adminPassphrase": typing.Type[passphrase.Passphrase],
        "systemTime": typing.Type[SystemTime],
    }
)


class ProvisionRequestDataDict(schemas.immutabledict[str, str]):

    __required_keys__: typing.FrozenSet[str] = frozenset({
        "adminPassphrase",
        "systemTime",
        "unlockPassphrase",
    })
    __optional_keys__: typing.FrozenSet[str] = frozenset({
    })
    
    def __new__(
        cls,
        *,
        adminPassphrase: str,
        systemTime: typing.Union[
            str,
            datetime.datetime
        ],
        unlockPassphrase: str,
        configuration_: typing.Optional[schema_configuration.SchemaConfiguration] = None,
        **kwargs: schemas.INPUT_TYPES_ALL,
    ):
        arg_: typing.Dict[str, typing.Any] = {
            "adminPassphrase": adminPassphrase,
            "systemTime": systemTime,
            "unlockPassphrase": unlockPassphrase,
        }
        arg_.update(kwargs)
        used_arg_ = typing.cast(ProvisionRequestDataDictInput, arg_)
        return ProvisionRequestData.validate(used_arg_, configuration=configuration_)
    
    @staticmethod
    def from_dict_(
        arg: typing.Union[
            ProvisionRequestDataDictInput,
            ProvisionRequestDataDict
        ],
        configuration: typing.Optional[schema_configuration.SchemaConfiguration] = None
    ) -> ProvisionRequestDataDict:
        return ProvisionRequestData.validate(arg, configuration=configuration)
    
    @property
    def adminPassphrase(self) -> str:
        return typing.cast(
            str,
            self.__getitem__("adminPassphrase")
        )
    
    @property
    def systemTime(self) -> str:
        return typing.cast(
            str,
            self.__getitem__("systemTime")
        )
    
    @property
    def unlockPassphrase(self) -> str:
        return typing.cast(
            str,
            self.__getitem__("unlockPassphrase")
        )
    
    def get_additional_property_(self, name: str) -> typing.Union[schemas.OUTPUT_BASE_TYPES, schemas.Unset]:
        schemas.raise_if_key_known(name, self.__required_keys__, self.__optional_keys__)
        return self.get(name, schemas.unset)
ProvisionRequestDataDictInput = typing.Mapping[str, schemas.INPUT_TYPES_ALL]


@dataclasses.dataclass(frozen=True)
class ProvisionRequestData(
    schemas.Schema[ProvisionRequestDataDict, tuple]
):
    """NOTE: This class is auto generated by OpenAPI JSON Schema Generator.
    Ref: https://github.com/openapi-json-schema-tools/openapi-json-schema-generator

    Do not edit the class manually.
    """
    types: typing.FrozenSet[typing.Type] = frozenset({schemas.immutabledict})
    required: typing.FrozenSet[str] = frozenset({
        "adminPassphrase",
        "systemTime",
        "unlockPassphrase",
    })
    properties: Properties = dataclasses.field(default_factory=lambda: schemas.typed_dict_to_instance(Properties)) # type: ignore
    type_to_output_cls: typing.Mapping[
        typing.Type,
        typing.Type
    ] = dataclasses.field(
        default_factory=lambda: {
            schemas.immutabledict: ProvisionRequestDataDict
        }
    )

    @classmethod
    def validate(
        cls,
        arg: typing.Union[
            ProvisionRequestDataDictInput,
            ProvisionRequestDataDict,
        ],
        configuration: typing.Optional[schema_configuration.SchemaConfiguration] = None
    ) -> ProvisionRequestDataDict:
        return super().validate_base(
            arg,
            configuration=configuration,
        )

